/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CAN Bus Message</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.CANBusMessage#getFormat <em>Format</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.CANBusMessage#getCanId <em>Can Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.CANBusMessage#getSize <em>Size</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getCANBusMessage()
 * @model
 * @generated
 */
public interface CANBusMessage extends BusMessage {
	/**
	 * Returns the value of the '<em><b>Format</b></em>' attribute.
	 * The default value is <code>"Standard"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.CANBusMessageFormat}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Format</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Format</em>' attribute.
	 * @see com.inchron.realtime.root.model.CANBusMessageFormat
	 * @see #setFormat(CANBusMessageFormat)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCANBusMessage_Format()
	 * @model default="Standard" required="true"
	 * @generated
	 */
	CANBusMessageFormat getFormat();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CANBusMessage#getFormat <em>Format</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Format</em>' attribute.
	 * @see com.inchron.realtime.root.model.CANBusMessageFormat
	 * @see #getFormat()
	 * @generated
	 */
	void setFormat(CANBusMessageFormat value);

	/**
	 * Returns the value of the '<em><b>Can Id</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Can Id</em>' attribute.
	 * @see #setCanId(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCANBusMessage_CanId()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getCanId();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CANBusMessage#getCanId <em>Can Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Can Id</em>' attribute.
	 * @see #getCanId()
	 * @generated
	 */
	void setCanId(int value);

	/**
	 * Returns the value of the '<em><b>Size</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Size</em>' attribute.
	 * @see #setSize(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCANBusMessage_Size()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getSize();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CANBusMessage#getSize <em>Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Size</em>' attribute.
	 * @see #getSize()
	 * @generated
	 */
	void setSize(int value);

} // CANBusMessage
