/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Clock</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.Clock#getFrequency <em>Frequency</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Clock#getPeriod <em>Period</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Clock#getDrift <em>Drift</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Clock#getRange <em>Range</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Clock#getStartTimeFixed <em>Start Time Fixed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Clock#isStartTimeIsRandom <em>Start Time Is Random</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Clock#getStartTimeMin <em>Start Time Min</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Clock#getStartTimeMax <em>Start Time Max</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Clock#getStartValue <em>Start Value</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Clock#getUsers <em>Users</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getClock()
 * @model
 * @generated
 */
public interface Clock extends ModelObject, TraceObject {
	/**
	 * Returns the value of the '<em><b>Frequency</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Frequency</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Frequency</em>' containment reference.
	 * @see #setFrequency(Frequency)
	 * @see com.inchron.realtime.root.model.ModelPackage#getClock_Frequency()
	 * @model containment="true"
	 * @generated
	 */
	Frequency getFrequency();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Clock#getFrequency <em>Frequency</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Frequency</em>' containment reference.
	 * @see #getFrequency()
	 * @generated
	 */
	void setFrequency(Frequency value);

	/**
	 * Returns the value of the '<em><b>Period</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Period</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Period</em>' containment reference.
	 * @see #setPeriod(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getClock_Period()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	Time getPeriod();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Clock#getPeriod <em>Period</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Period</em>' containment reference.
	 * @see #getPeriod()
	 * @generated
	 */
	void setPeriod(Time value);

	/**
	 * Returns the value of the '<em><b>Drift</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Drift</em>' attribute.
	 * @see #setDrift(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getClock_Drift()
	 * @model default="0" required="true" ordered="false"
	 * @generated
	 */
	int getDrift();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Clock#getDrift <em>Drift</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Drift</em>' attribute.
	 * @see #getDrift()
	 * @generated
	 */
	void setDrift(int value);

	/**
	 * Returns the value of the '<em><b>Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Range</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Range</em>' containment reference.
	 * @see #setRange(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getClock_Range()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	Time getRange();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Clock#getRange <em>Range</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Range</em>' containment reference.
	 * @see #getRange()
	 * @generated
	 */
	void setRange(Time value);

	/**
	 * Returns the value of the '<em><b>Start Time Fixed</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Time Fixed</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Time Fixed</em>' containment reference.
	 * @see #setStartTimeFixed(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getClock_StartTimeFixed()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getStartTimeFixed();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Clock#getStartTimeFixed <em>Start Time Fixed</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Time Fixed</em>' containment reference.
	 * @see #getStartTimeFixed()
	 * @generated
	 */
	void setStartTimeFixed(Time value);

	/**
	 * Returns the value of the '<em><b>Start Time Is Random</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Time Is Random</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Time Is Random</em>' attribute.
	 * @see #setStartTimeIsRandom(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getClock_StartTimeIsRandom()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isStartTimeIsRandom();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Clock#isStartTimeIsRandom <em>Start Time Is Random</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Time Is Random</em>' attribute.
	 * @see #isStartTimeIsRandom()
	 * @generated
	 */
	void setStartTimeIsRandom(boolean value);

	/**
	 * Returns the value of the '<em><b>Start Time Min</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Time Min</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Time Min</em>' containment reference.
	 * @see #setStartTimeMin(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getClock_StartTimeMin()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getStartTimeMin();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Clock#getStartTimeMin <em>Start Time Min</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Time Min</em>' containment reference.
	 * @see #getStartTimeMin()
	 * @generated
	 */
	void setStartTimeMin(Time value);

	/**
	 * Returns the value of the '<em><b>Start Time Max</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Time Max</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Time Max</em>' containment reference.
	 * @see #setStartTimeMax(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getClock_StartTimeMax()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getStartTimeMax();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Clock#getStartTimeMax <em>Start Time Max</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Time Max</em>' containment reference.
	 * @see #getStartTimeMax()
	 * @generated
	 */
	void setStartTimeMax(Time value);

	/**
	 * Returns the value of the '<em><b>Start Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Value</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Value</em>' containment reference.
	 * @see #setStartValue(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getClock_StartValue()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	Time getStartValue();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Clock#getStartValue <em>Start Value</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Value</em>' containment reference.
	 * @see #getStartValue()
	 * @generated
	 */
	void setStartValue(Time value);

	/**
	 * Returns the value of the '<em><b>Users</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.ClockUser}.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.ClockUser#getClock <em>Clock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Users</em>' reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getClock_Users()
	 * @see com.inchron.realtime.root.model.ClockUser#getClock
	 * @model opposite="clock"
	 * @generated
	 */
	EList<ClockUser> getUsers();

} // Clock
