/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Estimator Settings</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.EstimatorSettings#getModel <em>Model</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.EstimatorSettings#getOptCompiler <em>Opt Compiler</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.EstimatorSettings#getOptVersion <em>Opt Version</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.EstimatorSettings#getOptLabels <em>Opt Labels</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.EstimatorSettings#getOptFlags <em>Opt Flags</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.EstimatorSettings#getSelectedOpt <em>Selected Opt</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getEstimatorSettings()
 * @model
 * @generated
 */
public interface EstimatorSettings extends EObject {
	/**
	 * Returns the value of the '<em><b>Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Model</em>' containment reference.
	 * @see #setModel(AbstractCpuModel)
	 * @see com.inchron.realtime.root.model.ModelPackage#getEstimatorSettings_Model()
	 * @model containment="true"
	 * @generated
	 */
	AbstractCpuModel getModel();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.EstimatorSettings#getModel <em>Model</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Model</em>' containment reference.
	 * @see #getModel()
	 * @generated
	 */
	void setModel(AbstractCpuModel value);

	/**
	 * Returns the value of the '<em><b>Opt Compiler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Opt Compiler</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Opt Compiler</em>' attribute.
	 * @see #setOptCompiler(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getEstimatorSettings_OptCompiler()
	 * @model
	 * @generated
	 */
	String getOptCompiler();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.EstimatorSettings#getOptCompiler <em>Opt Compiler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Opt Compiler</em>' attribute.
	 * @see #getOptCompiler()
	 * @generated
	 */
	void setOptCompiler(String value);

	/**
	 * Returns the value of the '<em><b>Opt Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Opt Version</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Opt Version</em>' attribute.
	 * @see #setOptVersion(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getEstimatorSettings_OptVersion()
	 * @model
	 * @generated
	 */
	String getOptVersion();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.EstimatorSettings#getOptVersion <em>Opt Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Opt Version</em>' attribute.
	 * @see #getOptVersion()
	 * @generated
	 */
	void setOptVersion(String value);

	/**
	 * Returns the value of the '<em><b>Opt Labels</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.String}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Opt Labels</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Opt Labels</em>' attribute list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getEstimatorSettings_OptLabels()
	 * @model
	 * @generated
	 */
	EList<String> getOptLabels();

	/**
	 * Returns the value of the '<em><b>Opt Flags</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.String}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Opt Flags</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Opt Flags</em>' attribute list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getEstimatorSettings_OptFlags()
	 * @model
	 * @generated
	 */
	EList<String> getOptFlags();

	/**
	 * Returns the value of the '<em><b>Selected Opt</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Selected Opt</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Selected Opt</em>' attribute.
	 * @see #setSelectedOpt(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getEstimatorSettings_SelectedOpt()
	 * @model default="0"
	 * @generated
	 */
	int getSelectedOpt();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.EstimatorSettings#getSelectedOpt <em>Selected Opt</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Selected Opt</em>' attribute.
	 * @see #getSelectedOpt()
	 * @generated
	 */
	void setSelectedOpt(int value);

} // EstimatorSettings
