/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import com.inchron.realtime.root.model.memory.DataAccess;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Resource Consumption</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.ResourceConsumption#getDataAccess <em>Data Access</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ResourceConsumption#getEntryFunction <em>Entry Function</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ResourceConsumption#getStackUsage <em>Stack Usage</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ResourceConsumption#getTimeDistribution <em>Time Distribution</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ResourceConsumption#isUseEntryFunction <em>Use Entry Function</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getResourceConsumption()
 * @model
 * @generated
 */
public interface ResourceConsumption extends CallSequenceItem {
	/**
	 * Returns the value of the '<em><b>Data Access</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.memory.DataAccess}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Data Access</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data Access</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getResourceConsumption_DataAccess()
	 * @model containment="true"
	 * @generated
	 */
	EList<DataAccess> getDataAccess();

	/**
	 * Returns the value of the '<em><b>Entry Function</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Entry Function</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Entry Function</em>' reference.
	 * @see #setEntryFunction(SourceFunction)
	 * @see com.inchron.realtime.root.model.ModelPackage#getResourceConsumption_EntryFunction()
	 * @model
	 * @generated
	 */
	SourceFunction getEntryFunction();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ResourceConsumption#getEntryFunction <em>Entry Function</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Entry Function</em>' reference.
	 * @see #getEntryFunction()
	 * @generated
	 */
	void setEntryFunction(SourceFunction value);

	/**
	 * Returns the value of the '<em><b>Stack Usage</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stack Usage</em>' attribute.
	 * @see #setStackUsage(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getResourceConsumption_StackUsage()
	 * @model default="0"
	 * @generated
	 */
	int getStackUsage();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ResourceConsumption#getStackUsage <em>Stack Usage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stack Usage</em>' attribute.
	 * @see #getStackUsage()
	 * @generated
	 */
	void setStackUsage(int value);

	/**
	 * Returns the value of the '<em><b>Time Distribution</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Time Distribution</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Time Distribution</em>' containment reference.
	 * @see #setTimeDistribution(TimeDistribution)
	 * @see com.inchron.realtime.root.model.ModelPackage#getResourceConsumption_TimeDistribution()
	 * @model containment="true" required="true"
	 * @generated
	 */
	TimeDistribution getTimeDistribution();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ResourceConsumption#getTimeDistribution <em>Time Distribution</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Time Distribution</em>' containment reference.
	 * @see #getTimeDistribution()
	 * @generated
	 */
	void setTimeDistribution(TimeDistribution value);

	/**
	 * Returns the value of the '<em><b>Use Entry Function</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Use Entry Function</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Use Entry Function</em>' attribute.
	 * @see #setUseEntryFunction(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getResourceConsumption_UseEntryFunction()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isUseEntryFunction();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ResourceConsumption#isUseEntryFunction <em>Use Entry Function</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Use Entry Function</em>' attribute.
	 * @see #isUseEntryFunction()
	 * @generated
	 */
	void setUseEntryFunction(boolean value);

} // ResourceConsumption
