/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.ClockUser;
import com.inchron.realtime.root.model.ModelObject;
import com.inchron.realtime.root.model.Time;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Os Counter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsCounter#getDelay <em>Delay</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsCounter#getGranularity <em>Granularity</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsCounter#isHardware <em>Hardware</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsCounter#getMincycle <em>Mincycle</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsCounter#getRange <em>Range</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsCounter#getReferenceTicks <em>Reference Ticks</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsCounter()
 * @model
 * @generated
 */
public interface OsCounter extends ModelObject, ClockUser {
	/**
	 * Returns the value of the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Delay</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Delay</em>' containment reference.
	 * @see #setDelay(Time)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsCounter_Delay()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	Time getDelay();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsCounter#getDelay <em>Delay</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Delay</em>' containment reference.
	 * @see #getDelay()
	 * @generated
	 */
	void setDelay(Time value);

	/**
	 * Returns the value of the '<em><b>Granularity</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Granularity</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Granularity</em>' attribute.
	 * @see #setGranularity(long)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsCounter_Granularity()
	 * @model default="1" required="true" ordered="false"
	 * @generated
	 */
	long getGranularity();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsCounter#getGranularity <em>Granularity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Granularity</em>' attribute.
	 * @see #getGranularity()
	 * @generated
	 */
	void setGranularity(long value);

	/**
	 * Returns the value of the '<em><b>Hardware</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Hardware</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Hardware</em>' attribute.
	 * @see #setHardware(boolean)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsCounter_Hardware()
	 * @model default="true" required="true" ordered="false"
	 * @generated
	 */
	boolean isHardware();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsCounter#isHardware <em>Hardware</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Hardware</em>' attribute.
	 * @see #isHardware()
	 * @generated
	 */
	void setHardware(boolean value);

	/**
	 * Returns the value of the '<em><b>Mincycle</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mincycle</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mincycle</em>' attribute.
	 * @see #setMincycle(long)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsCounter_Mincycle()
	 * @model default="0" required="true" ordered="false"
	 * @generated
	 */
	long getMincycle();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsCounter#getMincycle <em>Mincycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mincycle</em>' attribute.
	 * @see #getMincycle()
	 * @generated
	 */
	void setMincycle(long value);

	/**
	 * Returns the value of the '<em><b>Range</b></em>' attribute.
	 * The default value is <code>"1000"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Range</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Range</em>' attribute.
	 * @see #setRange(long)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsCounter_Range()
	 * @model default="1000" required="true" ordered="false"
	 * @generated
	 */
	long getRange();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsCounter#getRange <em>Range</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Range</em>' attribute.
	 * @see #getRange()
	 * @generated
	 */
	void setRange(long value);

	/**
	 * Returns the value of the '<em><b>Reference Ticks</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reference Ticks</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reference Ticks</em>' attribute.
	 * @see #setReferenceTicks(long)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsCounter_ReferenceTicks()
	 * @model default="1" required="true" ordered="false"
	 * @generated
	 */
	long getReferenceTicks();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsCounter#getReferenceTicks <em>Reference Ticks</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Reference Ticks</em>' attribute.
	 * @see #getReferenceTicks()
	 * @generated
	 */
	void setReferenceTicks(long value);

} // OsCounter
