/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.CallSequenceItem;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Server Call</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.ServerCall#getInvokedOperation <em>Invoked Operation</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getServerCall()
 * @model
 * @generated
 */
public interface ServerCall extends CallSequenceItem {
	/**
	 * Returns the value of the '<em><b>Invoked Operation</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Invoked Operation</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Invoked Operation</em>' reference.
	 * @see #setInvokedOperation(Operation)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getServerCall_InvokedOperation()
	 * @model required="true"
	 * @generated
	 */
	Operation getInvokedOperation();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.ServerCall#getInvokedOperation <em>Invoked Operation</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Invoked Operation</em>' reference.
	 * @see #getInvokedOperation()
	 * @generated
	 */
	void setInvokedOperation(Operation value);

} // ServerCall
