/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.type;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Enumeration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.type.Enumeration#getItems <em>Items</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.type.Enumeration#getQuantity <em>Quantity</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.fmi.type.TypePackage#getEnumeration()
 * @model
 * @generated
 */
public interface Enumeration extends SimpleType {
	/**
	 * Returns the value of the '<em><b>Items</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.fmi.type.Item}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Items</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Items</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.fmi.type.TypePackage#getEnumeration_Items()
	 * @model containment="true" required="true"
	 * @generated
	 */
	EList<Item> getItems();

	/**
	 * Returns the value of the '<em><b>Quantity</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Quantity</em>' attribute.
	 * @see #setQuantity(String)
	 * @see com.inchron.realtime.root.model.fmi.type.TypePackage#getEnumeration_Quantity()
	 * @model default=""
	 * @generated
	 */
	String getQuantity();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.type.Enumeration#getQuantity <em>Quantity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Quantity</em>' attribute.
	 * @see #getQuantity()
	 * @generated
	 */
	void setQuantity(String value);

} // Enumeration
