/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.unit;

import com.inchron.realtime.root.model.ModelObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Display Unit</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.DisplayUnit#getFactor <em>Factor</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.DisplayUnit#getOffset <em>Offset</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getDisplayUnit()
 * @model
 * @generated
 */
public interface DisplayUnit extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Factor</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Factor</em>' attribute.
	 * @see #setFactor(double)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getDisplayUnit_Factor()
	 * @model default="1"
	 * @generated
	 */
	double getFactor();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.DisplayUnit#getFactor <em>Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Factor</em>' attribute.
	 * @see #getFactor()
	 * @generated
	 */
	void setFactor(double value);

	/**
	 * Returns the value of the '<em><b>Offset</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Offset</em>' attribute.
	 * @see #setOffset(double)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getDisplayUnit_Offset()
	 * @model default="0"
	 * @generated
	 */
	double getOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.DisplayUnit#getOffset <em>Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Offset</em>' attribute.
	 * @see #getOffset()
	 * @generated
	 */
	void setOffset(double value);

} // DisplayUnit
