/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.variable.impl;

import com.inchron.realtime.root.model.CallGraph;
import com.inchron.realtime.root.model.Connection;

import com.inchron.realtime.root.model.fmi.variable.Causality;
import com.inchron.realtime.root.model.fmi.variable.Initial;
import com.inchron.realtime.root.model.fmi.variable.ScalarVariable;
import com.inchron.realtime.root.model.fmi.variable.TriggerType;
import com.inchron.realtime.root.model.fmi.variable.Variability;
import com.inchron.realtime.root.model.fmi.variable.VariablePackage;

import com.inchron.realtime.root.model.peripheral.impl.AbstractPortImpl;

import java.lang.Integer;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Scalar Variable</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl#getCallGraph <em>Call Graph</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl#getCausality <em>Causality</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl#getConnections <em>Connections</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl#getInitial <em>Initial</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl#getTriggerType <em>Trigger Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl#getValueReference <em>Value Reference</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl#getVariability <em>Variability</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class ScalarVariableImpl extends AbstractPortImpl implements ScalarVariable {
	/**
	 * The cached value of the '{@link #getCallGraph() <em>Call Graph</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCallGraph()
	 * @generated
	 * @ordered
	 */
	protected CallGraph callGraph;

	/**
	 * The default value of the '{@link #getCausality() <em>Causality</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCausality()
	 * @generated
	 * @ordered
	 */
	protected static final Causality CAUSALITY_EDEFAULT = Causality.LOCAL;

	/**
	 * The cached value of the '{@link #getCausality() <em>Causality</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCausality()
	 * @generated
	 * @ordered
	 */
	protected Causality causality = CAUSALITY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getConnections() <em>Connections</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConnections()
	 * @generated
	 * @ordered
	 */
	protected EList<Connection> connections;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = "";

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getInitial() <em>Initial</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitial()
	 * @generated
	 * @ordered
	 */
	protected static final Initial INITIAL_EDEFAULT = Initial.UNSET;

	/**
	 * The cached value of the '{@link #getInitial() <em>Initial</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitial()
	 * @generated
	 * @ordered
	 */
	protected Initial initial = INITIAL_EDEFAULT;

	/**
	 * The default value of the '{@link #getTriggerType() <em>Trigger Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTriggerType()
	 * @generated
	 * @ordered
	 */
	protected static final TriggerType TRIGGER_TYPE_EDEFAULT = TriggerType.ON_CHANGE;

	/**
	 * The cached value of the '{@link #getTriggerType() <em>Trigger Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTriggerType()
	 * @generated
	 * @ordered
	 */
	protected TriggerType triggerType = TRIGGER_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getValueReference() <em>Value Reference</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValueReference()
	 * @generated
	 * @ordered
	 */
	protected static final int VALUE_REFERENCE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getValueReference() <em>Value Reference</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValueReference()
	 * @generated
	 * @ordered
	 */
	protected int valueReference = VALUE_REFERENCE_EDEFAULT;

	/**
	 * The default value of the '{@link #getVariability() <em>Variability</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVariability()
	 * @generated
	 * @ordered
	 */
	protected static final Variability VARIABILITY_EDEFAULT = Variability.CONTINUOUS;

	/**
	 * The cached value of the '{@link #getVariability() <em>Variability</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVariability()
	 * @generated
	 * @ordered
	 */
	protected Variability variability = VARIABILITY_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ScalarVariableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return VariablePackage.Literals.SCALAR_VARIABLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallGraph getCallGraph() {
		return callGraph;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCallGraph(CallGraph newCallGraph, NotificationChain msgs) {
		CallGraph oldCallGraph = callGraph;
		callGraph = newCallGraph;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, VariablePackage.SCALAR_VARIABLE__CALL_GRAPH, oldCallGraph, newCallGraph);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCallGraph(CallGraph newCallGraph) {
		if (newCallGraph != callGraph) {
			NotificationChain msgs = null;
			if (callGraph != null)
				msgs = ((InternalEObject)callGraph).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - VariablePackage.SCALAR_VARIABLE__CALL_GRAPH, null, msgs);
			if (newCallGraph != null)
				msgs = ((InternalEObject)newCallGraph).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - VariablePackage.SCALAR_VARIABLE__CALL_GRAPH, null, msgs);
			msgs = basicSetCallGraph(newCallGraph, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.SCALAR_VARIABLE__CALL_GRAPH, newCallGraph, newCallGraph));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Causality getCausality() {
		return causality;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCausality(Causality newCausality) {
		Causality oldCausality = causality;
		causality = newCausality == null ? CAUSALITY_EDEFAULT : newCausality;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.SCALAR_VARIABLE__CAUSALITY, oldCausality, causality));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Connection> getConnections() {
		if (connections == null) {
			connections = new EObjectContainmentEList<Connection>(Connection.class, this, VariablePackage.SCALAR_VARIABLE__CONNECTIONS);
		}
		return connections;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.SCALAR_VARIABLE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Initial getInitial() {
		return initial;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInitial(Initial newInitial) {
		Initial oldInitial = initial;
		initial = newInitial == null ? INITIAL_EDEFAULT : newInitial;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.SCALAR_VARIABLE__INITIAL, oldInitial, initial));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TriggerType getTriggerType() {
		return triggerType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTriggerType(TriggerType newTriggerType) {
		TriggerType oldTriggerType = triggerType;
		triggerType = newTriggerType == null ? TRIGGER_TYPE_EDEFAULT : newTriggerType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.SCALAR_VARIABLE__TRIGGER_TYPE, oldTriggerType, triggerType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValueReference() {
		return valueReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setValueReference(int newValueReference) {
		int oldValueReference = valueReference;
		valueReference = newValueReference;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.SCALAR_VARIABLE__VALUE_REFERENCE, oldValueReference, valueReference));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Variability getVariability() {
		return variability;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVariability(Variability newVariability) {
		Variability oldVariability = variability;
		variability = newVariability == null ? VARIABILITY_EDEFAULT : newVariability;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.SCALAR_VARIABLE__VARIABILITY, oldVariability, variability));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case VariablePackage.SCALAR_VARIABLE__CALL_GRAPH:
				return basicSetCallGraph(null, msgs);
			case VariablePackage.SCALAR_VARIABLE__CONNECTIONS:
				return ((InternalEList<?>)getConnections()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case VariablePackage.SCALAR_VARIABLE__CALL_GRAPH:
				return getCallGraph();
			case VariablePackage.SCALAR_VARIABLE__CAUSALITY:
				return getCausality();
			case VariablePackage.SCALAR_VARIABLE__CONNECTIONS:
				return getConnections();
			case VariablePackage.SCALAR_VARIABLE__DESCRIPTION:
				return getDescription();
			case VariablePackage.SCALAR_VARIABLE__INITIAL:
				return getInitial();
			case VariablePackage.SCALAR_VARIABLE__TRIGGER_TYPE:
				return getTriggerType();
			case VariablePackage.SCALAR_VARIABLE__VALUE_REFERENCE:
				return getValueReference();
			case VariablePackage.SCALAR_VARIABLE__VARIABILITY:
				return getVariability();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case VariablePackage.SCALAR_VARIABLE__CALL_GRAPH:
				setCallGraph((CallGraph)newValue);
				return;
			case VariablePackage.SCALAR_VARIABLE__CAUSALITY:
				setCausality((Causality)newValue);
				return;
			case VariablePackage.SCALAR_VARIABLE__CONNECTIONS:
				getConnections().clear();
				getConnections().addAll((Collection<? extends Connection>)newValue);
				return;
			case VariablePackage.SCALAR_VARIABLE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case VariablePackage.SCALAR_VARIABLE__INITIAL:
				setInitial((Initial)newValue);
				return;
			case VariablePackage.SCALAR_VARIABLE__TRIGGER_TYPE:
				setTriggerType((TriggerType)newValue);
				return;
			case VariablePackage.SCALAR_VARIABLE__VALUE_REFERENCE:
				setValueReference((Integer)newValue);
				return;
			case VariablePackage.SCALAR_VARIABLE__VARIABILITY:
				setVariability((Variability)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case VariablePackage.SCALAR_VARIABLE__CALL_GRAPH:
				setCallGraph((CallGraph)null);
				return;
			case VariablePackage.SCALAR_VARIABLE__CAUSALITY:
				setCausality(CAUSALITY_EDEFAULT);
				return;
			case VariablePackage.SCALAR_VARIABLE__CONNECTIONS:
				getConnections().clear();
				return;
			case VariablePackage.SCALAR_VARIABLE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case VariablePackage.SCALAR_VARIABLE__INITIAL:
				setInitial(INITIAL_EDEFAULT);
				return;
			case VariablePackage.SCALAR_VARIABLE__TRIGGER_TYPE:
				setTriggerType(TRIGGER_TYPE_EDEFAULT);
				return;
			case VariablePackage.SCALAR_VARIABLE__VALUE_REFERENCE:
				setValueReference(VALUE_REFERENCE_EDEFAULT);
				return;
			case VariablePackage.SCALAR_VARIABLE__VARIABILITY:
				setVariability(VARIABILITY_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case VariablePackage.SCALAR_VARIABLE__CALL_GRAPH:
				return callGraph != null;
			case VariablePackage.SCALAR_VARIABLE__CAUSALITY:
				return causality != CAUSALITY_EDEFAULT;
			case VariablePackage.SCALAR_VARIABLE__CONNECTIONS:
				return connections != null && !connections.isEmpty();
			case VariablePackage.SCALAR_VARIABLE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case VariablePackage.SCALAR_VARIABLE__INITIAL:
				return initial != INITIAL_EDEFAULT;
			case VariablePackage.SCALAR_VARIABLE__TRIGGER_TYPE:
				return triggerType != TRIGGER_TYPE_EDEFAULT;
			case VariablePackage.SCALAR_VARIABLE__VALUE_REFERENCE:
				return valueReference != VALUE_REFERENCE_EDEFAULT;
			case VariablePackage.SCALAR_VARIABLE__VARIABILITY:
				return variability != VARIABILITY_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (causality: ");
		result.append(causality);
		result.append(", description: ");
		result.append(description);
		result.append(", initial: ");
		result.append(initial);
		result.append(", triggerType: ");
		result.append(triggerType);
		result.append(", valueReference: ");
		result.append(valueReference);
		result.append(", variability: ");
		result.append(variability);
		result.append(')');
		return result.toString();
	}

} //ScalarVariableImpl
