/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.AbstractCpuModel;
import com.inchron.realtime.root.model.EstimatorSettings;
import com.inchron.realtime.root.model.ModelPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Estimator Settings</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.EstimatorSettingsImpl#getModel <em>Model</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.EstimatorSettingsImpl#getOptCompiler <em>Opt Compiler</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.EstimatorSettingsImpl#getOptVersion <em>Opt Version</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.EstimatorSettingsImpl#getOptLabels <em>Opt Labels</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.EstimatorSettingsImpl#getOptFlags <em>Opt Flags</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.EstimatorSettingsImpl#getSelectedOpt <em>Selected Opt</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EstimatorSettingsImpl extends MinimalEObjectImpl.Container implements EstimatorSettings {
	/**
	 * The cached value of the '{@link #getModel() <em>Model</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModel()
	 * @generated
	 * @ordered
	 */
	protected AbstractCpuModel model;

	/**
	 * The default value of the '{@link #getOptCompiler() <em>Opt Compiler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOptCompiler()
	 * @generated
	 * @ordered
	 */
	protected static final String OPT_COMPILER_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getOptCompiler() <em>Opt Compiler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOptCompiler()
	 * @generated
	 * @ordered
	 */
	protected String optCompiler = OPT_COMPILER_EDEFAULT;

	/**
	 * The default value of the '{@link #getOptVersion() <em>Opt Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOptVersion()
	 * @generated
	 * @ordered
	 */
	protected static final String OPT_VERSION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getOptVersion() <em>Opt Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOptVersion()
	 * @generated
	 * @ordered
	 */
	protected String optVersion = OPT_VERSION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getOptLabels() <em>Opt Labels</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOptLabels()
	 * @generated
	 * @ordered
	 */
	protected EList<String> optLabels;

	/**
	 * The cached value of the '{@link #getOptFlags() <em>Opt Flags</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOptFlags()
	 * @generated
	 * @ordered
	 */
	protected EList<String> optFlags;

	/**
	 * The default value of the '{@link #getSelectedOpt() <em>Selected Opt</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSelectedOpt()
	 * @generated
	 * @ordered
	 */
	protected static final int SELECTED_OPT_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getSelectedOpt() <em>Selected Opt</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSelectedOpt()
	 * @generated
	 * @ordered
	 */
	protected int selectedOpt = SELECTED_OPT_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EstimatorSettingsImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getEstimatorSettings();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AbstractCpuModel getModel() {
		return model;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetModel(AbstractCpuModel newModel, NotificationChain msgs) {
		AbstractCpuModel oldModel = model;
		model = newModel;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.ESTIMATOR_SETTINGS__MODEL, oldModel, newModel);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setModel(AbstractCpuModel newModel) {
		if (newModel != model) {
			NotificationChain msgs = null;
			if (model != null)
				msgs = ((InternalEObject)model).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.ESTIMATOR_SETTINGS__MODEL, null, msgs);
			if (newModel != null)
				msgs = ((InternalEObject)newModel).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.ESTIMATOR_SETTINGS__MODEL, null, msgs);
			msgs = basicSetModel(newModel, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.ESTIMATOR_SETTINGS__MODEL, newModel, newModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getOptCompiler() {
		return optCompiler;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOptCompiler(String newOptCompiler) {
		String oldOptCompiler = optCompiler;
		optCompiler = newOptCompiler;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.ESTIMATOR_SETTINGS__OPT_COMPILER, oldOptCompiler, optCompiler));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getOptVersion() {
		return optVersion;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOptVersion(String newOptVersion) {
		String oldOptVersion = optVersion;
		optVersion = newOptVersion;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.ESTIMATOR_SETTINGS__OPT_VERSION, oldOptVersion, optVersion));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getOptLabels() {
		if (optLabels == null) {
			optLabels = new EDataTypeUniqueEList<String>(String.class, this, ModelPackage.ESTIMATOR_SETTINGS__OPT_LABELS);
		}
		return optLabels;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getOptFlags() {
		if (optFlags == null) {
			optFlags = new EDataTypeUniqueEList<String>(String.class, this, ModelPackage.ESTIMATOR_SETTINGS__OPT_FLAGS);
		}
		return optFlags;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSelectedOpt() {
		return selectedOpt;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSelectedOpt(int newSelectedOpt) {
		int oldSelectedOpt = selectedOpt;
		selectedOpt = newSelectedOpt;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.ESTIMATOR_SETTINGS__SELECTED_OPT, oldSelectedOpt, selectedOpt));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.ESTIMATOR_SETTINGS__MODEL:
				return basicSetModel(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.ESTIMATOR_SETTINGS__MODEL:
				return getModel();
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_COMPILER:
				return getOptCompiler();
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_VERSION:
				return getOptVersion();
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_LABELS:
				return getOptLabels();
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_FLAGS:
				return getOptFlags();
			case ModelPackage.ESTIMATOR_SETTINGS__SELECTED_OPT:
				return getSelectedOpt();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.ESTIMATOR_SETTINGS__MODEL:
				setModel((AbstractCpuModel)newValue);
				return;
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_COMPILER:
				setOptCompiler((String)newValue);
				return;
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_VERSION:
				setOptVersion((String)newValue);
				return;
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_LABELS:
				getOptLabels().clear();
				getOptLabels().addAll((Collection<? extends String>)newValue);
				return;
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_FLAGS:
				getOptFlags().clear();
				getOptFlags().addAll((Collection<? extends String>)newValue);
				return;
			case ModelPackage.ESTIMATOR_SETTINGS__SELECTED_OPT:
				setSelectedOpt((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.ESTIMATOR_SETTINGS__MODEL:
				setModel((AbstractCpuModel)null);
				return;
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_COMPILER:
				setOptCompiler(OPT_COMPILER_EDEFAULT);
				return;
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_VERSION:
				setOptVersion(OPT_VERSION_EDEFAULT);
				return;
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_LABELS:
				getOptLabels().clear();
				return;
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_FLAGS:
				getOptFlags().clear();
				return;
			case ModelPackage.ESTIMATOR_SETTINGS__SELECTED_OPT:
				setSelectedOpt(SELECTED_OPT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.ESTIMATOR_SETTINGS__MODEL:
				return model != null;
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_COMPILER:
				return OPT_COMPILER_EDEFAULT == null ? optCompiler != null : !OPT_COMPILER_EDEFAULT.equals(optCompiler);
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_VERSION:
				return OPT_VERSION_EDEFAULT == null ? optVersion != null : !OPT_VERSION_EDEFAULT.equals(optVersion);
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_LABELS:
				return optLabels != null && !optLabels.isEmpty();
			case ModelPackage.ESTIMATOR_SETTINGS__OPT_FLAGS:
				return optFlags != null && !optFlags.isEmpty();
			case ModelPackage.ESTIMATOR_SETTINGS__SELECTED_OPT:
				return selectedOpt != SELECTED_OPT_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (optCompiler: ");
		result.append(optCompiler);
		result.append(", optVersion: ");
		result.append(optVersion);
		result.append(", optLabels: ");
		result.append(optLabels);
		result.append(", optFlags: ");
		result.append(optFlags);
		result.append(", selectedOpt: ");
		result.append(selectedOpt);
		result.append(')');
		return result.toString();
	}

} //EstimatorSettingsImpl
