/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.GenericSystem;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.RtosConfig;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Generic System</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.GenericSystemImpl#getRtosConfig <em>Rtos Config</em>}</li>
 * </ul>
 *
 * @generated
 */
public class GenericSystemImpl extends SystemImpl implements GenericSystem {
	/**
	 * The cached value of the '{@link #getRtosConfig() <em>Rtos Config</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRtosConfig()
	 * @generated
	 * @ordered
	 */
	protected RtosConfig rtosConfig;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GenericSystemImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getGenericSystem();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RtosConfig getRtosConfig() {
		return rtosConfig;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetRtosConfig(RtosConfig newRtosConfig, NotificationChain msgs) {
		RtosConfig oldRtosConfig = rtosConfig;
		rtosConfig = newRtosConfig;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.GENERIC_SYSTEM__RTOS_CONFIG, oldRtosConfig, newRtosConfig);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRtosConfig(RtosConfig newRtosConfig) {
		if (newRtosConfig != rtosConfig) {
			NotificationChain msgs = null;
			if (rtosConfig != null)
				msgs = ((InternalEObject)rtosConfig).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.GENERIC_SYSTEM__RTOS_CONFIG, null, msgs);
			if (newRtosConfig != null)
				msgs = ((InternalEObject)newRtosConfig).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.GENERIC_SYSTEM__RTOS_CONFIG, null, msgs);
			msgs = basicSetRtosConfig(newRtosConfig, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.GENERIC_SYSTEM__RTOS_CONFIG, newRtosConfig, newRtosConfig));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.GENERIC_SYSTEM__RTOS_CONFIG:
				return basicSetRtosConfig(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.GENERIC_SYSTEM__RTOS_CONFIG:
				return getRtosConfig();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.GENERIC_SYSTEM__RTOS_CONFIG:
				setRtosConfig((RtosConfig)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.GENERIC_SYSTEM__RTOS_CONFIG:
				setRtosConfig((RtosConfig)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.GENERIC_SYSTEM__RTOS_CONFIG:
				return rtosConfig != null;
		}
		return super.eIsSet(featureID);
	}

} //GenericSystemImpl
