/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.SpecSettings;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Spec Settings</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.SpecSettingsImpl#getIncludes <em>Includes</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SpecSettingsImpl#getMacros <em>Macros</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SpecSettingsImpl#isPrependSettings <em>Prepend Settings</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SpecSettingsImpl extends MinimalEObjectImpl.Container implements SpecSettings {
	/**
	 * The default value of the '{@link #getIncludes() <em>Includes</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIncludes()
	 * @generated
	 * @ordered
	 */
	protected static final String INCLUDES_EDEFAULT = " ";

	/**
	 * The cached value of the '{@link #getIncludes() <em>Includes</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIncludes()
	 * @generated
	 * @ordered
	 */
	protected String includes = INCLUDES_EDEFAULT;

	/**
	 * The default value of the '{@link #getMacros() <em>Macros</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMacros()
	 * @generated
	 * @ordered
	 */
	protected static final String MACROS_EDEFAULT = " ";

	/**
	 * The cached value of the '{@link #getMacros() <em>Macros</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMacros()
	 * @generated
	 * @ordered
	 */
	protected String macros = MACROS_EDEFAULT;

	/**
	 * The default value of the '{@link #isPrependSettings() <em>Prepend Settings</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPrependSettings()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PREPEND_SETTINGS_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isPrependSettings() <em>Prepend Settings</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPrependSettings()
	 * @generated
	 * @ordered
	 */
	protected boolean prependSettings = PREPEND_SETTINGS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SpecSettingsImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getSpecSettings();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getIncludes() {
		return includes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIncludes(String newIncludes) {
		String oldIncludes = includes;
		includes = newIncludes;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SPEC_SETTINGS__INCLUDES, oldIncludes, includes));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getMacros() {
		return macros;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMacros(String newMacros) {
		String oldMacros = macros;
		macros = newMacros;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SPEC_SETTINGS__MACROS, oldMacros, macros));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isPrependSettings() {
		return prependSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrependSettings(boolean newPrependSettings) {
		boolean oldPrependSettings = prependSettings;
		prependSettings = newPrependSettings;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SPEC_SETTINGS__PREPEND_SETTINGS, oldPrependSettings, prependSettings));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.SPEC_SETTINGS__INCLUDES:
				return getIncludes();
			case ModelPackage.SPEC_SETTINGS__MACROS:
				return getMacros();
			case ModelPackage.SPEC_SETTINGS__PREPEND_SETTINGS:
				return isPrependSettings();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.SPEC_SETTINGS__INCLUDES:
				setIncludes((String)newValue);
				return;
			case ModelPackage.SPEC_SETTINGS__MACROS:
				setMacros((String)newValue);
				return;
			case ModelPackage.SPEC_SETTINGS__PREPEND_SETTINGS:
				setPrependSettings((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.SPEC_SETTINGS__INCLUDES:
				setIncludes(INCLUDES_EDEFAULT);
				return;
			case ModelPackage.SPEC_SETTINGS__MACROS:
				setMacros(MACROS_EDEFAULT);
				return;
			case ModelPackage.SPEC_SETTINGS__PREPEND_SETTINGS:
				setPrependSettings(PREPEND_SETTINGS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.SPEC_SETTINGS__INCLUDES:
				return INCLUDES_EDEFAULT == null ? includes != null : !INCLUDES_EDEFAULT.equals(includes);
			case ModelPackage.SPEC_SETTINGS__MACROS:
				return MACROS_EDEFAULT == null ? macros != null : !MACROS_EDEFAULT.equals(macros);
			case ModelPackage.SPEC_SETTINGS__PREPEND_SETTINGS:
				return prependSettings != PREPEND_SETTINGS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (includes: ");
		result.append(includes);
		result.append(", macros: ");
		result.append(macros);
		result.append(", prependSettings: ");
		result.append(prependSettings);
		result.append(')');
		return result.toString();
	}

} //SpecSettingsImpl
