/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory;

import com.inchron.realtime.root.model.ClockUser;
import com.inchron.realtime.root.model.ModelObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Interconnect</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.memory.Interconnect#getBitWidth <em>Bit Width</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.Interconnect#getSchedulingPolicy <em>Scheduling Policy</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.Interconnect#getConnectedSlaves <em>Connected Slaves</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.Interconnect#getConnectedMasters <em>Connected Masters</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.Interconnect#getPrescaler <em>Prescaler</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.Interconnect#getQosEntries <em>Qos Entries</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getInterconnect()
 * @model
 * @generated
 */
public interface Interconnect extends ModelObject, ClockUser {
	/**
	 * Returns the value of the '<em><b>Bit Width</b></em>' attribute.
	 * The default value is <code>"32"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bit Width</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Bit Width</em>' attribute.
	 * @see #setBitWidth(int)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getInterconnect_BitWidth()
	 * @model default="32"
	 * @generated
	 */
	int getBitWidth();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.Interconnect#getBitWidth <em>Bit Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Bit Width</em>' attribute.
	 * @see #getBitWidth()
	 * @generated
	 */
	void setBitWidth(int value);

	/**
	 * Returns the value of the '<em><b>Scheduling Policy</b></em>' attribute.
	 * The default value is <code>"Priority"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.memory.InterconnectScheduling}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Scheduling Policy</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Scheduling Policy</em>' attribute.
	 * @see com.inchron.realtime.root.model.memory.InterconnectScheduling
	 * @see #setSchedulingPolicy(InterconnectScheduling)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getInterconnect_SchedulingPolicy()
	 * @model default="Priority"
	 * @generated
	 */
	InterconnectScheduling getSchedulingPolicy();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.Interconnect#getSchedulingPolicy <em>Scheduling Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Scheduling Policy</em>' attribute.
	 * @see com.inchron.realtime.root.model.memory.InterconnectScheduling
	 * @see #getSchedulingPolicy()
	 * @generated
	 */
	void setSchedulingPolicy(InterconnectScheduling value);

	/**
	 * Returns the value of the '<em><b>Connected Slaves</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.memory.InitiatorPort}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connected Slaves</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connected Slaves</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getInterconnect_ConnectedSlaves()
	 * @model containment="true"
	 * @generated
	 */
	EList<InitiatorPort> getConnectedSlaves();

	/**
	 * Returns the value of the '<em><b>Connected Masters</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.memory.ResponderPort}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connected Masters</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connected Masters</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getInterconnect_ConnectedMasters()
	 * @model containment="true"
	 * @generated
	 */
	EList<ResponderPort> getConnectedMasters();

	/**
	 * Returns the value of the '<em><b>Prescaler</b></em>' attribute.
	 * The default value is <code>"1.0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Prescaler</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Prescaler</em>' attribute.
	 * @see #setPrescaler(double)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getInterconnect_Prescaler()
	 * @model default="1.0"
	 * @generated
	 */
	double getPrescaler();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.Interconnect#getPrescaler <em>Prescaler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Prescaler</em>' attribute.
	 * @see #getPrescaler()
	 * @generated
	 */
	void setPrescaler(double value);

	/**
	 * Returns the value of the '<em><b>Qos Entries</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.memory.QosEntry}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Qos Entries</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Qos Entries</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getInterconnect_QosEntries()
	 * @model containment="true"
	 * @generated
	 */
	EList<QosEntry> getQosEntries();

} // Interconnect
