/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;

import com.inchron.realtime.root.model.ModelObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Port Connection</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.PortConnection#getPorts <em>Ports</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getPortConnection()
 * @model
 * @generated
 */
public interface PortConnection extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Ports</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.peripheral.AbstractPort}.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.peripheral.AbstractPort#getConnection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ports</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ports</em>' reference list.
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getPortConnection_Ports()
	 * @see com.inchron.realtime.root.model.peripheral.AbstractPort#getConnection
	 * @model opposite="connection" ordered="false"
	 * @generated
	 */
	EList<AbstractPort> getPorts();

} // PortConnection
