/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.BufferStrategy;

import com.inchron.realtime.root.model.peripheral.CAN;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>CAN</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.CANImpl#getBufferStrategy <em>Buffer Strategy</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.CANImpl#getNumberOfBuffers <em>Number Of Buffers</em>}</li>
 * </ul>
 *
 * @generated
 */
public class CANImpl extends PeripheralImpl implements CAN {
	/**
	 * The default value of the '{@link #getBufferStrategy() <em>Buffer Strategy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBufferStrategy()
	 * @generated
	 * @ordered
	 */
	protected static final BufferStrategy BUFFER_STRATEGY_EDEFAULT = BufferStrategy.SLOT_ORDER;

	/**
	 * The cached value of the '{@link #getBufferStrategy() <em>Buffer Strategy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBufferStrategy()
	 * @generated
	 * @ordered
	 */
	protected BufferStrategy bufferStrategy = BUFFER_STRATEGY_EDEFAULT;

	/**
	 * The default value of the '{@link #getNumberOfBuffers() <em>Number Of Buffers</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumberOfBuffers()
	 * @generated
	 * @ordered
	 */
	protected static final int NUMBER_OF_BUFFERS_EDEFAULT = 256;

	/**
	 * The cached value of the '{@link #getNumberOfBuffers() <em>Number Of Buffers</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumberOfBuffers()
	 * @generated
	 * @ordered
	 */
	protected int numberOfBuffers = NUMBER_OF_BUFFERS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CANImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.CAN;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BufferStrategy getBufferStrategy() {
		return bufferStrategy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBufferStrategy(BufferStrategy newBufferStrategy) {
		BufferStrategy oldBufferStrategy = bufferStrategy;
		bufferStrategy = newBufferStrategy == null ? BUFFER_STRATEGY_EDEFAULT : newBufferStrategy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.CAN__BUFFER_STRATEGY, oldBufferStrategy, bufferStrategy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getNumberOfBuffers() {
		return numberOfBuffers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNumberOfBuffers(int newNumberOfBuffers) {
		int oldNumberOfBuffers = numberOfBuffers;
		numberOfBuffers = newNumberOfBuffers;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.CAN__NUMBER_OF_BUFFERS, oldNumberOfBuffers, numberOfBuffers));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.CAN__BUFFER_STRATEGY:
				return getBufferStrategy();
			case PeripheralPackage.CAN__NUMBER_OF_BUFFERS:
				return getNumberOfBuffers();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.CAN__BUFFER_STRATEGY:
				setBufferStrategy((BufferStrategy)newValue);
				return;
			case PeripheralPackage.CAN__NUMBER_OF_BUFFERS:
				setNumberOfBuffers((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.CAN__BUFFER_STRATEGY:
				setBufferStrategy(BUFFER_STRATEGY_EDEFAULT);
				return;
			case PeripheralPackage.CAN__NUMBER_OF_BUFFERS:
				setNumberOfBuffers(NUMBER_OF_BUFFERS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.CAN__BUFFER_STRATEGY:
				return bufferStrategy != BUFFER_STRATEGY_EDEFAULT;
			case PeripheralPackage.CAN__NUMBER_OF_BUFFERS:
				return numberOfBuffers != NUMBER_OF_BUFFERS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (bufferStrategy: ");
		result.append(bufferStrategy);
		result.append(", numberOfBuffers: ");
		result.append(numberOfBuffers);
		result.append(')');
		return result.toString();
	}

} //CANImpl
