/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.peripheral.EthernetSwitch;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Ethernet Switch</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.EthernetSwitchImpl#isFastForward <em>Fast Forward</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.EthernetSwitchImpl#isLogEnabled <em>Log Enabled</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EthernetSwitchImpl extends AbstractEthernetImpl implements EthernetSwitch {
	/**
	 * The default value of the '{@link #isFastForward() <em>Fast Forward</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isFastForward()
	 * @generated
	 * @ordered
	 */
	protected static final boolean FAST_FORWARD_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isFastForward() <em>Fast Forward</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isFastForward()
	 * @generated
	 * @ordered
	 */
	protected boolean fastForward = FAST_FORWARD_EDEFAULT;

	/**
	 * The default value of the '{@link #isLogEnabled() <em>Log Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLogEnabled()
	 * @generated
	 * @ordered
	 */
	protected static final boolean LOG_ENABLED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isLogEnabled() <em>Log Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLogEnabled()
	 * @generated
	 * @ordered
	 */
	protected boolean logEnabled = LOG_ENABLED_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EthernetSwitchImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.ETHERNET_SWITCH;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isFastForward() {
		return fastForward;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFastForward(boolean newFastForward) {
		boolean oldFastForward = fastForward;
		fastForward = newFastForward;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ETHERNET_SWITCH__FAST_FORWARD, oldFastForward, fastForward));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isLogEnabled() {
		return logEnabled;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLogEnabled(boolean newLogEnabled) {
		boolean oldLogEnabled = logEnabled;
		logEnabled = newLogEnabled;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ETHERNET_SWITCH__LOG_ENABLED, oldLogEnabled, logEnabled));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.ETHERNET_SWITCH__FAST_FORWARD:
				return isFastForward();
			case PeripheralPackage.ETHERNET_SWITCH__LOG_ENABLED:
				return isLogEnabled();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.ETHERNET_SWITCH__FAST_FORWARD:
				setFastForward((Boolean)newValue);
				return;
			case PeripheralPackage.ETHERNET_SWITCH__LOG_ENABLED:
				setLogEnabled((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.ETHERNET_SWITCH__FAST_FORWARD:
				setFastForward(FAST_FORWARD_EDEFAULT);
				return;
			case PeripheralPackage.ETHERNET_SWITCH__LOG_ENABLED:
				setLogEnabled(LOG_ENABLED_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.ETHERNET_SWITCH__FAST_FORWARD:
				return fastForward != FAST_FORWARD_EDEFAULT;
			case PeripheralPackage.ETHERNET_SWITCH__LOG_ENABLED:
				return logEnabled != LOG_ENABLED_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (fastForward: ");
		result.append(fastForward);
		result.append(", logEnabled: ");
		result.append(logEnabled);
		result.append(')');
		return result.toString();
	}

} //EthernetSwitchImpl
