/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>RTOS Failure</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getRTOSFailure()
 * @model
 * @generated
 */
public enum RTOSFailure implements Enumerator {
	/**
	 * The '<em><b>Return From Task Forbidden</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #RETURN_FROM_TASK_FORBIDDEN_VALUE
	 * @generated
	 * @ordered
	 */
	RETURN_FROM_TASK_FORBIDDEN(0, "ReturnFromTaskForbidden", "ReturnFromTaskForbidden"),

	/**
	 * The '<em><b>Activation Limit Violation</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ACTIVATION_LIMIT_VIOLATION_VALUE
	 * @generated
	 * @ordered
	 */
	ACTIVATION_LIMIT_VIOLATION(1, "ActivationLimitViolation", "ActivationLimitViolation"),

	/**
	 * The '<em><b>Memory Access Violation</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MEMORY_ACCESS_VIOLATION_VALUE
	 * @generated
	 * @ordered
	 */
	MEMORY_ACCESS_VIOLATION(2, "MemoryAccessViolation", "MemoryAccessViolation"),

	/**
	 * The '<em><b>Division By Zero</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DIVISION_BY_ZERO_VALUE
	 * @generated
	 * @ordered
	 */
	DIVISION_BY_ZERO(3, "DivisionByZero", "DivisionByZero"),

	/**
	 * The '<em><b>Invalid Object</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INVALID_OBJECT_VALUE
	 * @generated
	 * @ordered
	 */
	INVALID_OBJECT(4, "InvalidObject", "InvalidObject"),

	/**
	 * The '<em><b>Os Api Call Error</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #OS_API_CALL_ERROR_VALUE
	 * @generated
	 * @ordered
	 */
	OS_API_CALL_ERROR(5, "OsApiCallError", "OsApiCallError"),

	/**
	 * The '<em><b>Isr Lost</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ISR_LOST_VALUE
	 * @generated
	 * @ordered
	 */
	ISR_LOST(6, "IsrLost", "IsrLost"),

	/**
	 * The '<em><b>Deleted Used Object</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DELETED_USED_OBJECT_VALUE
	 * @generated
	 * @ordered
	 */
	DELETED_USED_OBJECT(7, "DeletedUsedObject", "DeletedUsedObject"),

	/**
	 * The '<em><b>Timer Lost</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIMER_LOST_VALUE
	 * @generated
	 * @ordered
	 */
	TIMER_LOST(8, "TimerLost", "TimerLost"),

	/**
	 * The '<em><b>Deadline Violation</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DEADLINE_VIOLATION_VALUE
	 * @generated
	 * @ordered
	 */
	DEADLINE_VIOLATION(9, "DeadlineViolation", "DeadlineViolation"),

	/**
	 * The '<em><b>Osek Resource Order Wrong</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #OSEK_RESOURCE_ORDER_WRONG_VALUE
	 * @generated
	 * @ordered
	 */
	OSEK_RESOURCE_ORDER_WRONG(10, "OsekResourceOrderWrong", "OsekResourceOrderWrong"),

	/**
	 * The '<em><b>Assert Failed</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ASSERT_FAILED_VALUE
	 * @generated
	 * @ordered
	 */
	ASSERT_FAILED(11, "AssertFailed", "AssertFailed"),

	/**
	 * The '<em><b>Cxx Pure Virtual Called</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CXX_PURE_VIRTUAL_CALLED_VALUE
	 * @generated
	 * @ordered
	 */
	CXX_PURE_VIRTUAL_CALLED(12, "CxxPureVirtualCalled", "CxxPureVirtualCalled"),

	/**
	 * The '<em><b>Heap Corruption Detected</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HEAP_CORRUPTION_DETECTED_VALUE
	 * @generated
	 * @ordered
	 */
	HEAP_CORRUPTION_DETECTED(13, "HeapCorruptionDetected", "HeapCorruptionDetected"),

	/**
	 * The '<em><b>Import Error</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #IMPORT_ERROR_VALUE
	 * @generated
	 * @ordered
	 */
	IMPORT_ERROR(14, "ImportError", "ImportError"),

	/**
	 * The '<em><b>Import Source Error</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #IMPORT_SOURCE_ERROR_VALUE
	 * @generated
	 * @ordered
	 */
	IMPORT_SOURCE_ERROR(15, "ImportSourceError", "ImportSourceError"),

	/**
	 * The '<em><b>Canoe IF Sreduced</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CANOE_IF_SREDUCED_VALUE
	 * @generated
	 * @ordered
	 */
	CANOE_IF_SREDUCED(16, "CanoeIFSreduced", "CanoeIFSreduced"),

	/**
	 * The '<em><b>Canoe IF Sviolated</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CANOE_IF_SVIOLATED_VALUE
	 * @generated
	 * @ordered
	 */
	CANOE_IF_SVIOLATED(17, "CanoeIFSviolated", "CanoeIFSviolated"),

	/**
	 * The '<em><b>Spinlock Order Wrong</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SPINLOCK_ORDER_WRONG_VALUE
	 * @generated
	 * @ordered
	 */
	SPINLOCK_ORDER_WRONG(18, "SpinlockOrderWrong", "SpinlockOrderWrong"),

	/**
	 * The '<em><b>Memory Write Access Violation</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MEMORY_WRITE_ACCESS_VIOLATION_VALUE
	 * @generated
	 * @ordered
	 */
	MEMORY_WRITE_ACCESS_VIOLATION(19, "MemoryWriteAccessViolation", "MemoryWriteAccessViolation"),

	/**
	 * The '<em><b>Memory Read Modify Write Access Violation</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MEMORY_READ_MODIFY_WRITE_ACCESS_VIOLATION_VALUE
	 * @generated
	 * @ordered
	 */
	MEMORY_READ_MODIFY_WRITE_ACCESS_VIOLATION(20, "MemoryReadModifyWriteAccessViolation", "MemoryReadModifyWriteAccessViolation"),

	/**
	 * The '<em><b>Memory Address Map Violation</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MEMORY_ADDRESS_MAP_VIOLATION_VALUE
	 * @generated
	 * @ordered
	 */
	MEMORY_ADDRESS_MAP_VIOLATION(21, "MemoryAddressMapViolation", "MemoryAddressMapViolation"),

	/**
	 * The '<em><b>Can Message Dropped</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CAN_MESSAGE_DROPPED_VALUE
	 * @generated
	 * @ordered
	 */
	CAN_MESSAGE_DROPPED(22, "CanMessageDropped", "CanMessageDropped");

	/**
	 * The '<em><b>Return From Task Forbidden</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Return From Task Forbidden</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #RETURN_FROM_TASK_FORBIDDEN
	 * @model name="ReturnFromTaskForbidden"
	 * @generated
	 * @ordered
	 */
	public static final int RETURN_FROM_TASK_FORBIDDEN_VALUE = 0;

	/**
	 * The '<em><b>Activation Limit Violation</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Activation Limit Violation</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ACTIVATION_LIMIT_VIOLATION
	 * @model name="ActivationLimitViolation"
	 * @generated
	 * @ordered
	 */
	public static final int ACTIVATION_LIMIT_VIOLATION_VALUE = 1;

	/**
	 * The '<em><b>Memory Access Violation</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Memory Access Violation</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MEMORY_ACCESS_VIOLATION
	 * @model name="MemoryAccessViolation"
	 * @generated
	 * @ordered
	 */
	public static final int MEMORY_ACCESS_VIOLATION_VALUE = 2;

	/**
	 * The '<em><b>Division By Zero</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Division By Zero</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DIVISION_BY_ZERO
	 * @model name="DivisionByZero"
	 * @generated
	 * @ordered
	 */
	public static final int DIVISION_BY_ZERO_VALUE = 3;

	/**
	 * The '<em><b>Invalid Object</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Invalid Object</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INVALID_OBJECT
	 * @model name="InvalidObject"
	 * @generated
	 * @ordered
	 */
	public static final int INVALID_OBJECT_VALUE = 4;

	/**
	 * The '<em><b>Os Api Call Error</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Os Api Call Error</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #OS_API_CALL_ERROR
	 * @model name="OsApiCallError"
	 * @generated
	 * @ordered
	 */
	public static final int OS_API_CALL_ERROR_VALUE = 5;

	/**
	 * The '<em><b>Isr Lost</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Isr Lost</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ISR_LOST
	 * @model name="IsrLost"
	 * @generated
	 * @ordered
	 */
	public static final int ISR_LOST_VALUE = 6;

	/**
	 * The '<em><b>Deleted Used Object</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Deleted Used Object</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DELETED_USED_OBJECT
	 * @model name="DeletedUsedObject"
	 * @generated
	 * @ordered
	 */
	public static final int DELETED_USED_OBJECT_VALUE = 7;

	/**
	 * The '<em><b>Timer Lost</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Timer Lost</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIMER_LOST
	 * @model name="TimerLost"
	 * @generated
	 * @ordered
	 */
	public static final int TIMER_LOST_VALUE = 8;

	/**
	 * The '<em><b>Deadline Violation</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Deadline Violation</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DEADLINE_VIOLATION
	 * @model name="DeadlineViolation"
	 * @generated
	 * @ordered
	 */
	public static final int DEADLINE_VIOLATION_VALUE = 9;

	/**
	 * The '<em><b>Osek Resource Order Wrong</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Osek Resource Order Wrong</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #OSEK_RESOURCE_ORDER_WRONG
	 * @model name="OsekResourceOrderWrong"
	 * @generated
	 * @ordered
	 */
	public static final int OSEK_RESOURCE_ORDER_WRONG_VALUE = 10;

	/**
	 * The '<em><b>Assert Failed</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Assert Failed</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ASSERT_FAILED
	 * @model name="AssertFailed"
	 * @generated
	 * @ordered
	 */
	public static final int ASSERT_FAILED_VALUE = 11;

	/**
	 * The '<em><b>Cxx Pure Virtual Called</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Cxx Pure Virtual Called</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CXX_PURE_VIRTUAL_CALLED
	 * @model name="CxxPureVirtualCalled"
	 * @generated
	 * @ordered
	 */
	public static final int CXX_PURE_VIRTUAL_CALLED_VALUE = 12;

	/**
	 * The '<em><b>Heap Corruption Detected</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Heap Corruption Detected</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HEAP_CORRUPTION_DETECTED
	 * @model name="HeapCorruptionDetected"
	 * @generated
	 * @ordered
	 */
	public static final int HEAP_CORRUPTION_DETECTED_VALUE = 13;

	/**
	 * The '<em><b>Import Error</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Import Error</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #IMPORT_ERROR
	 * @model name="ImportError"
	 * @generated
	 * @ordered
	 */
	public static final int IMPORT_ERROR_VALUE = 14;

	/**
	 * The '<em><b>Import Source Error</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Import Source Error</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #IMPORT_SOURCE_ERROR
	 * @model name="ImportSourceError"
	 * @generated
	 * @ordered
	 */
	public static final int IMPORT_SOURCE_ERROR_VALUE = 15;

	/**
	 * The '<em><b>Canoe IF Sreduced</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Canoe IF Sreduced</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CANOE_IF_SREDUCED
	 * @model name="CanoeIFSreduced"
	 * @generated
	 * @ordered
	 */
	public static final int CANOE_IF_SREDUCED_VALUE = 16;

	/**
	 * The '<em><b>Canoe IF Sviolated</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Canoe IF Sviolated</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CANOE_IF_SVIOLATED
	 * @model name="CanoeIFSviolated"
	 * @generated
	 * @ordered
	 */
	public static final int CANOE_IF_SVIOLATED_VALUE = 17;

	/**
	 * The '<em><b>Spinlock Order Wrong</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Spinlock Order Wrong</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SPINLOCK_ORDER_WRONG
	 * @model name="SpinlockOrderWrong"
	 * @generated
	 * @ordered
	 */
	public static final int SPINLOCK_ORDER_WRONG_VALUE = 18;

	/**
	 * The '<em><b>Memory Write Access Violation</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Memory Write Access Violation</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MEMORY_WRITE_ACCESS_VIOLATION
	 * @model name="MemoryWriteAccessViolation"
	 * @generated
	 * @ordered
	 */
	public static final int MEMORY_WRITE_ACCESS_VIOLATION_VALUE = 19;

	/**
	 * The '<em><b>Memory Read Modify Write Access Violation</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Memory Read Modify Write Access Violation</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MEMORY_READ_MODIFY_WRITE_ACCESS_VIOLATION
	 * @model name="MemoryReadModifyWriteAccessViolation"
	 * @generated
	 * @ordered
	 */
	public static final int MEMORY_READ_MODIFY_WRITE_ACCESS_VIOLATION_VALUE = 20;

	/**
	 * The '<em><b>Memory Address Map Violation</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Memory Address Map Violation</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MEMORY_ADDRESS_MAP_VIOLATION
	 * @model name="MemoryAddressMapViolation"
	 * @generated
	 * @ordered
	 */
	public static final int MEMORY_ADDRESS_MAP_VIOLATION_VALUE = 21;

	/**
	 * The '<em><b>Can Message Dropped</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Can Message Dropped</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CAN_MESSAGE_DROPPED
	 * @model name="CanMessageDropped"
	 * @generated
	 * @ordered
	 */
	public static final int CAN_MESSAGE_DROPPED_VALUE = 22;

	/**
	 * An array of all the '<em><b>RTOS Failure</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final RTOSFailure[] VALUES_ARRAY =
		new RTOSFailure[] {
			RETURN_FROM_TASK_FORBIDDEN,
			ACTIVATION_LIMIT_VIOLATION,
			MEMORY_ACCESS_VIOLATION,
			DIVISION_BY_ZERO,
			INVALID_OBJECT,
			OS_API_CALL_ERROR,
			ISR_LOST,
			DELETED_USED_OBJECT,
			TIMER_LOST,
			DEADLINE_VIOLATION,
			OSEK_RESOURCE_ORDER_WRONG,
			ASSERT_FAILED,
			CXX_PURE_VIRTUAL_CALLED,
			HEAP_CORRUPTION_DETECTED,
			IMPORT_ERROR,
			IMPORT_SOURCE_ERROR,
			CANOE_IF_SREDUCED,
			CANOE_IF_SVIOLATED,
			SPINLOCK_ORDER_WRONG,
			MEMORY_WRITE_ACCESS_VIOLATION,
			MEMORY_READ_MODIFY_WRITE_ACCESS_VIOLATION,
			MEMORY_ADDRESS_MAP_VIOLATION,
			CAN_MESSAGE_DROPPED,
		};

	/**
	 * A public read-only list of all the '<em><b>RTOS Failure</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<RTOSFailure> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>RTOS Failure</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static RTOSFailure get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RTOSFailure result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>RTOS Failure</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static RTOSFailure getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RTOSFailure result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>RTOS Failure</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static RTOSFailure get(int value) {
		switch (value) {
			case RETURN_FROM_TASK_FORBIDDEN_VALUE: return RETURN_FROM_TASK_FORBIDDEN;
			case ACTIVATION_LIMIT_VIOLATION_VALUE: return ACTIVATION_LIMIT_VIOLATION;
			case MEMORY_ACCESS_VIOLATION_VALUE: return MEMORY_ACCESS_VIOLATION;
			case DIVISION_BY_ZERO_VALUE: return DIVISION_BY_ZERO;
			case INVALID_OBJECT_VALUE: return INVALID_OBJECT;
			case OS_API_CALL_ERROR_VALUE: return OS_API_CALL_ERROR;
			case ISR_LOST_VALUE: return ISR_LOST;
			case DELETED_USED_OBJECT_VALUE: return DELETED_USED_OBJECT;
			case TIMER_LOST_VALUE: return TIMER_LOST;
			case DEADLINE_VIOLATION_VALUE: return DEADLINE_VIOLATION;
			case OSEK_RESOURCE_ORDER_WRONG_VALUE: return OSEK_RESOURCE_ORDER_WRONG;
			case ASSERT_FAILED_VALUE: return ASSERT_FAILED;
			case CXX_PURE_VIRTUAL_CALLED_VALUE: return CXX_PURE_VIRTUAL_CALLED;
			case HEAP_CORRUPTION_DETECTED_VALUE: return HEAP_CORRUPTION_DETECTED;
			case IMPORT_ERROR_VALUE: return IMPORT_ERROR;
			case IMPORT_SOURCE_ERROR_VALUE: return IMPORT_SOURCE_ERROR;
			case CANOE_IF_SREDUCED_VALUE: return CANOE_IF_SREDUCED;
			case CANOE_IF_SVIOLATED_VALUE: return CANOE_IF_SVIOLATED;
			case SPINLOCK_ORDER_WRONG_VALUE: return SPINLOCK_ORDER_WRONG;
			case MEMORY_WRITE_ACCESS_VIOLATION_VALUE: return MEMORY_WRITE_ACCESS_VIOLATION;
			case MEMORY_READ_MODIFY_WRITE_ACCESS_VIOLATION_VALUE: return MEMORY_READ_MODIFY_WRITE_ACCESS_VIOLATION;
			case MEMORY_ADDRESS_MAP_VIOLATION_VALUE: return MEMORY_ADDRESS_MAP_VIOLATION;
			case CAN_MESSAGE_DROPPED_VALUE: return CAN_MESSAGE_DROPPED;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private RTOSFailure(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //RTOSFailure
