/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation.impl;

import com.inchron.realtime.root.model.Time;
import com.inchron.realtime.root.model.TimeDistribution;

import com.inchron.realtime.root.model.stimulation.BurstPattern;
import com.inchron.realtime.root.model.stimulation.BurstPatternGenerator;
import com.inchron.realtime.root.model.stimulation.StimulationPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Burst Pattern Generator</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternGeneratorImpl#getBurstPatternSettings <em>Burst Pattern Settings</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternGeneratorImpl#getIterations <em>Iterations</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternGeneratorImpl#getPeriod <em>Period</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternGeneratorImpl#isRelative <em>Relative</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternGeneratorImpl#getStartOffset <em>Start Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternGeneratorImpl#getStartOffsetVariation <em>Start Offset Variation</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternGeneratorImpl#getVariation <em>Variation</em>}</li>
 * </ul>
 *
 * @generated
 */
public class BurstPatternGeneratorImpl extends StimuliGeneratorImpl implements BurstPatternGenerator {
	/**
	 * The cached value of the '{@link #getBurstPatternSettings() <em>Burst Pattern Settings</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBurstPatternSettings()
	 * @generated
	 * @ordered
	 */
	protected BurstPattern burstPatternSettings;

	/**
	 * The default value of the '{@link #getIterations() <em>Iterations</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIterations()
	 * @generated
	 * @ordered
	 */
	protected static final int ITERATIONS_EDEFAULT = -1;

	/**
	 * The cached value of the '{@link #getIterations() <em>Iterations</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIterations()
	 * @generated
	 * @ordered
	 */
	protected int iterations = ITERATIONS_EDEFAULT;

	/**
	 * The cached value of the '{@link #getPeriod() <em>Period</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPeriod()
	 * @generated
	 * @ordered
	 */
	protected Time period;

	/**
	 * The default value of the '{@link #isRelative() <em>Relative</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRelative()
	 * @generated
	 * @ordered
	 */
	protected static final boolean RELATIVE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isRelative() <em>Relative</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRelative()
	 * @generated
	 * @ordered
	 */
	protected boolean relative = RELATIVE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStartOffset() <em>Start Offset</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartOffset()
	 * @generated
	 * @ordered
	 */
	protected Time startOffset;

	/**
	 * The cached value of the '{@link #getStartOffsetVariation() <em>Start Offset Variation</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartOffsetVariation()
	 * @generated
	 * @ordered
	 */
	protected TimeDistribution startOffsetVariation;

	/**
	 * The cached value of the '{@link #getVariation() <em>Variation</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVariation()
	 * @generated
	 * @ordered
	 */
	protected TimeDistribution variation;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BurstPatternGeneratorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return StimulationPackage.Literals.BURST_PATTERN_GENERATOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BurstPattern getBurstPatternSettings() {
		return burstPatternSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBurstPatternSettings(BurstPattern newBurstPatternSettings, NotificationChain msgs) {
		BurstPattern oldBurstPatternSettings = burstPatternSettings;
		burstPatternSettings = newBurstPatternSettings;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__BURST_PATTERN_SETTINGS, oldBurstPatternSettings, newBurstPatternSettings);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBurstPatternSettings(BurstPattern newBurstPatternSettings) {
		if (newBurstPatternSettings != burstPatternSettings) {
			NotificationChain msgs = null;
			if (burstPatternSettings != null)
				msgs = ((InternalEObject)burstPatternSettings).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN_GENERATOR__BURST_PATTERN_SETTINGS, null, msgs);
			if (newBurstPatternSettings != null)
				msgs = ((InternalEObject)newBurstPatternSettings).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN_GENERATOR__BURST_PATTERN_SETTINGS, null, msgs);
			msgs = basicSetBurstPatternSettings(newBurstPatternSettings, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__BURST_PATTERN_SETTINGS, newBurstPatternSettings, newBurstPatternSettings));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getIterations() {
		return iterations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIterations(int newIterations) {
		int oldIterations = iterations;
		iterations = newIterations;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__ITERATIONS, oldIterations, iterations));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getPeriod() {
		return period;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPeriod(Time newPeriod, NotificationChain msgs) {
		Time oldPeriod = period;
		period = newPeriod;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__PERIOD, oldPeriod, newPeriod);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPeriod(Time newPeriod) {
		if (newPeriod != period) {
			NotificationChain msgs = null;
			if (period != null)
				msgs = ((InternalEObject)period).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN_GENERATOR__PERIOD, null, msgs);
			if (newPeriod != null)
				msgs = ((InternalEObject)newPeriod).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN_GENERATOR__PERIOD, null, msgs);
			msgs = basicSetPeriod(newPeriod, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__PERIOD, newPeriod, newPeriod));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isRelative() {
		return relative;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRelative(boolean newRelative) {
		boolean oldRelative = relative;
		relative = newRelative;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__RELATIVE, oldRelative, relative));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getStartOffset() {
		return startOffset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStartOffset(Time newStartOffset, NotificationChain msgs) {
		Time oldStartOffset = startOffset;
		startOffset = newStartOffset;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET, oldStartOffset, newStartOffset);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartOffset(Time newStartOffset) {
		if (newStartOffset != startOffset) {
			NotificationChain msgs = null;
			if (startOffset != null)
				msgs = ((InternalEObject)startOffset).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET, null, msgs);
			if (newStartOffset != null)
				msgs = ((InternalEObject)newStartOffset).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET, null, msgs);
			msgs = basicSetStartOffset(newStartOffset, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET, newStartOffset, newStartOffset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeDistribution getStartOffsetVariation() {
		return startOffsetVariation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStartOffsetVariation(TimeDistribution newStartOffsetVariation, NotificationChain msgs) {
		TimeDistribution oldStartOffsetVariation = startOffsetVariation;
		startOffsetVariation = newStartOffsetVariation;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET_VARIATION, oldStartOffsetVariation, newStartOffsetVariation);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartOffsetVariation(TimeDistribution newStartOffsetVariation) {
		if (newStartOffsetVariation != startOffsetVariation) {
			NotificationChain msgs = null;
			if (startOffsetVariation != null)
				msgs = ((InternalEObject)startOffsetVariation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET_VARIATION, null, msgs);
			if (newStartOffsetVariation != null)
				msgs = ((InternalEObject)newStartOffsetVariation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET_VARIATION, null, msgs);
			msgs = basicSetStartOffsetVariation(newStartOffsetVariation, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET_VARIATION, newStartOffsetVariation, newStartOffsetVariation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeDistribution getVariation() {
		return variation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetVariation(TimeDistribution newVariation, NotificationChain msgs) {
		TimeDistribution oldVariation = variation;
		variation = newVariation;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__VARIATION, oldVariation, newVariation);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVariation(TimeDistribution newVariation) {
		if (newVariation != variation) {
			NotificationChain msgs = null;
			if (variation != null)
				msgs = ((InternalEObject)variation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN_GENERATOR__VARIATION, null, msgs);
			if (newVariation != null)
				msgs = ((InternalEObject)newVariation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN_GENERATOR__VARIATION, null, msgs);
			msgs = basicSetVariation(newVariation, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN_GENERATOR__VARIATION, newVariation, newVariation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StimulationPackage.BURST_PATTERN_GENERATOR__BURST_PATTERN_SETTINGS:
				return basicSetBurstPatternSettings(null, msgs);
			case StimulationPackage.BURST_PATTERN_GENERATOR__PERIOD:
				return basicSetPeriod(null, msgs);
			case StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET:
				return basicSetStartOffset(null, msgs);
			case StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET_VARIATION:
				return basicSetStartOffsetVariation(null, msgs);
			case StimulationPackage.BURST_PATTERN_GENERATOR__VARIATION:
				return basicSetVariation(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case StimulationPackage.BURST_PATTERN_GENERATOR__BURST_PATTERN_SETTINGS:
				return getBurstPatternSettings();
			case StimulationPackage.BURST_PATTERN_GENERATOR__ITERATIONS:
				return getIterations();
			case StimulationPackage.BURST_PATTERN_GENERATOR__PERIOD:
				return getPeriod();
			case StimulationPackage.BURST_PATTERN_GENERATOR__RELATIVE:
				return isRelative();
			case StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET:
				return getStartOffset();
			case StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET_VARIATION:
				return getStartOffsetVariation();
			case StimulationPackage.BURST_PATTERN_GENERATOR__VARIATION:
				return getVariation();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case StimulationPackage.BURST_PATTERN_GENERATOR__BURST_PATTERN_SETTINGS:
				setBurstPatternSettings((BurstPattern)newValue);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__ITERATIONS:
				setIterations((Integer)newValue);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__PERIOD:
				setPeriod((Time)newValue);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__RELATIVE:
				setRelative((Boolean)newValue);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET:
				setStartOffset((Time)newValue);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET_VARIATION:
				setStartOffsetVariation((TimeDistribution)newValue);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__VARIATION:
				setVariation((TimeDistribution)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case StimulationPackage.BURST_PATTERN_GENERATOR__BURST_PATTERN_SETTINGS:
				setBurstPatternSettings((BurstPattern)null);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__ITERATIONS:
				setIterations(ITERATIONS_EDEFAULT);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__PERIOD:
				setPeriod((Time)null);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__RELATIVE:
				setRelative(RELATIVE_EDEFAULT);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET:
				setStartOffset((Time)null);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET_VARIATION:
				setStartOffsetVariation((TimeDistribution)null);
				return;
			case StimulationPackage.BURST_PATTERN_GENERATOR__VARIATION:
				setVariation((TimeDistribution)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case StimulationPackage.BURST_PATTERN_GENERATOR__BURST_PATTERN_SETTINGS:
				return burstPatternSettings != null;
			case StimulationPackage.BURST_PATTERN_GENERATOR__ITERATIONS:
				return iterations != ITERATIONS_EDEFAULT;
			case StimulationPackage.BURST_PATTERN_GENERATOR__PERIOD:
				return period != null;
			case StimulationPackage.BURST_PATTERN_GENERATOR__RELATIVE:
				return relative != RELATIVE_EDEFAULT;
			case StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET:
				return startOffset != null;
			case StimulationPackage.BURST_PATTERN_GENERATOR__START_OFFSET_VARIATION:
				return startOffsetVariation != null;
			case StimulationPackage.BURST_PATTERN_GENERATOR__VARIATION:
				return variation != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (iterations: ");
		result.append(iterations);
		result.append(", relative: ");
		result.append(relative);
		result.append(')');
		return result.toString();
	}

} //BurstPatternGeneratorImpl
