/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>View Settings</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.settings.ViewSettings#getDiagrams <em>Diagrams</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.ViewSettings#isEventLabelsVisible <em>Event Labels Visible</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.ViewSettings#isHorizontalLabels <em>Horizontal Labels</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.ViewSettings#getCursors <em>Cursors</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.ViewSettings#getTraceEventTypeConfigurations <em>Trace Event Type Configurations</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.settings.SettingsPackage#getViewSettings()
 * @model
 * @generated
 */
public interface ViewSettings extends EObject {
	/**
	 * Returns the value of the '<em><b>Diagrams</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.settings.DiagramSettings}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Diagrams</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Diagrams</em>' containment reference list.
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getViewSettings_Diagrams()
	 * @model containment="true"
	 * @generated
	 */
	EList<DiagramSettings> getDiagrams();

	/**
	 * Returns the value of the '<em><b>Event Labels Visible</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Labels Visible</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Labels Visible</em>' attribute.
	 * @see #setEventLabelsVisible(boolean)
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getViewSettings_EventLabelsVisible()
	 * @model default="true"
	 * @generated
	 */
	boolean isEventLabelsVisible();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.settings.ViewSettings#isEventLabelsVisible <em>Event Labels Visible</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event Labels Visible</em>' attribute.
	 * @see #isEventLabelsVisible()
	 * @generated
	 */
	void setEventLabelsVisible(boolean value);

	/**
	 * Returns the value of the '<em><b>Horizontal Labels</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Horizontal Labels</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Horizontal Labels</em>' attribute.
	 * @see #setHorizontalLabels(boolean)
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getViewSettings_HorizontalLabels()
	 * @model default="false"
	 * @generated
	 */
	boolean isHorizontalLabels();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.settings.ViewSettings#isHorizontalLabels <em>Horizontal Labels</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Horizontal Labels</em>' attribute.
	 * @see #isHorizontalLabels()
	 * @generated
	 */
	void setHorizontalLabels(boolean value);

	/**
	 * Returns the value of the '<em><b>Cursors</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.settings.Cursor}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cursors</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cursors</em>' containment reference list.
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getViewSettings_Cursors()
	 * @model containment="true"
	 * @generated
	 */
	EList<Cursor> getCursors();

	/**
	 * Returns the value of the '<em><b>Trace Event Type Configurations</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.settings.TraceEventTypeConfiguration}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Trace Event Type Configurations</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Trace Event Type Configurations</em>' containment reference list.
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getViewSettings_TraceEventTypeConfigurations()
	 * @model containment="true"
	 * @generated
	 */
	EList<TraceEventTypeConfiguration> getTraceEventTypeConfigurations();

} // ViewSettings
