/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings.impl;

import com.inchron.realtime.root.settings.RandomSeed;
import com.inchron.realtime.root.settings.SettingsPackage;
import com.inchron.realtime.root.settings.SimulationSettings;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Simulation Settings</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.settings.impl.SimulationSettingsImpl#getRandomSeed <em>Random Seed</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SimulationSettingsImpl extends MinimalEObjectImpl.Container implements SimulationSettings {
	/**
	 * The cached value of the '{@link #getRandomSeed() <em>Random Seed</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRandomSeed()
	 * @generated
	 * @ordered
	 */
	protected RandomSeed randomSeed;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SimulationSettingsImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SettingsPackage.Literals.SIMULATION_SETTINGS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RandomSeed getRandomSeed() {
		return randomSeed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetRandomSeed(RandomSeed newRandomSeed, NotificationChain msgs) {
		RandomSeed oldRandomSeed = randomSeed;
		randomSeed = newRandomSeed;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SettingsPackage.SIMULATION_SETTINGS__RANDOM_SEED, oldRandomSeed, newRandomSeed);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRandomSeed(RandomSeed newRandomSeed) {
		if (newRandomSeed != randomSeed) {
			NotificationChain msgs = null;
			if (randomSeed != null)
				msgs = ((InternalEObject)randomSeed).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SettingsPackage.SIMULATION_SETTINGS__RANDOM_SEED, null, msgs);
			if (newRandomSeed != null)
				msgs = ((InternalEObject)newRandomSeed).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SettingsPackage.SIMULATION_SETTINGS__RANDOM_SEED, null, msgs);
			msgs = basicSetRandomSeed(newRandomSeed, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SettingsPackage.SIMULATION_SETTINGS__RANDOM_SEED, newRandomSeed, newRandomSeed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SettingsPackage.SIMULATION_SETTINGS__RANDOM_SEED:
				return basicSetRandomSeed(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SettingsPackage.SIMULATION_SETTINGS__RANDOM_SEED:
				return getRandomSeed();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SettingsPackage.SIMULATION_SETTINGS__RANDOM_SEED:
				setRandomSeed((RandomSeed)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SettingsPackage.SIMULATION_SETTINGS__RANDOM_SEED:
				setRandomSeed((RandomSeed)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SettingsPackage.SIMULATION_SETTINGS__RANDOM_SEED:
				return randomSeed != null;
		}
		return super.eIsSet(featureID);
	}

} //SimulationSettingsImpl
