/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings.impl;

import com.inchron.realtime.root.settings.Cursor;
import com.inchron.realtime.root.settings.DiagramSettings;
import com.inchron.realtime.root.settings.SettingsPackage;
import com.inchron.realtime.root.settings.TraceEventTypeConfiguration;
import com.inchron.realtime.root.settings.ViewSettings;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>View Settings</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.settings.impl.ViewSettingsImpl#getDiagrams <em>Diagrams</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.impl.ViewSettingsImpl#isEventLabelsVisible <em>Event Labels Visible</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.impl.ViewSettingsImpl#isHorizontalLabels <em>Horizontal Labels</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.impl.ViewSettingsImpl#getCursors <em>Cursors</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.impl.ViewSettingsImpl#getTraceEventTypeConfigurations <em>Trace Event Type Configurations</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ViewSettingsImpl extends MinimalEObjectImpl.Container implements ViewSettings {
	/**
	 * The cached value of the '{@link #getDiagrams() <em>Diagrams</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDiagrams()
	 * @generated
	 * @ordered
	 */
	protected EList<DiagramSettings> diagrams;

	/**
	 * The default value of the '{@link #isEventLabelsVisible() <em>Event Labels Visible</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEventLabelsVisible()
	 * @generated
	 * @ordered
	 */
	protected static final boolean EVENT_LABELS_VISIBLE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isEventLabelsVisible() <em>Event Labels Visible</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEventLabelsVisible()
	 * @generated
	 * @ordered
	 */
	protected boolean eventLabelsVisible = EVENT_LABELS_VISIBLE_EDEFAULT;

	/**
	 * The default value of the '{@link #isHorizontalLabels() <em>Horizontal Labels</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isHorizontalLabels()
	 * @generated
	 * @ordered
	 */
	protected static final boolean HORIZONTAL_LABELS_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isHorizontalLabels() <em>Horizontal Labels</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isHorizontalLabels()
	 * @generated
	 * @ordered
	 */
	protected boolean horizontalLabels = HORIZONTAL_LABELS_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCursors() <em>Cursors</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCursors()
	 * @generated
	 * @ordered
	 */
	protected EList<Cursor> cursors;

	/**
	 * The cached value of the '{@link #getTraceEventTypeConfigurations() <em>Trace Event Type Configurations</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTraceEventTypeConfigurations()
	 * @generated
	 * @ordered
	 */
	protected EList<TraceEventTypeConfiguration> traceEventTypeConfigurations;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ViewSettingsImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SettingsPackage.Literals.VIEW_SETTINGS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DiagramSettings> getDiagrams() {
		if (diagrams == null) {
			diagrams = new EObjectContainmentEList<DiagramSettings>(DiagramSettings.class, this, SettingsPackage.VIEW_SETTINGS__DIAGRAMS);
		}
		return diagrams;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isEventLabelsVisible() {
		return eventLabelsVisible;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEventLabelsVisible(boolean newEventLabelsVisible) {
		boolean oldEventLabelsVisible = eventLabelsVisible;
		eventLabelsVisible = newEventLabelsVisible;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SettingsPackage.VIEW_SETTINGS__EVENT_LABELS_VISIBLE, oldEventLabelsVisible, eventLabelsVisible));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isHorizontalLabels() {
		return horizontalLabels;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHorizontalLabels(boolean newHorizontalLabels) {
		boolean oldHorizontalLabels = horizontalLabels;
		horizontalLabels = newHorizontalLabels;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SettingsPackage.VIEW_SETTINGS__HORIZONTAL_LABELS, oldHorizontalLabels, horizontalLabels));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Cursor> getCursors() {
		if (cursors == null) {
			cursors = new EObjectContainmentEList<Cursor>(Cursor.class, this, SettingsPackage.VIEW_SETTINGS__CURSORS);
		}
		return cursors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TraceEventTypeConfiguration> getTraceEventTypeConfigurations() {
		if (traceEventTypeConfigurations == null) {
			traceEventTypeConfigurations = new EObjectContainmentEList<TraceEventTypeConfiguration>(TraceEventTypeConfiguration.class, this, SettingsPackage.VIEW_SETTINGS__TRACE_EVENT_TYPE_CONFIGURATIONS);
		}
		return traceEventTypeConfigurations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SettingsPackage.VIEW_SETTINGS__DIAGRAMS:
				return ((InternalEList<?>)getDiagrams()).basicRemove(otherEnd, msgs);
			case SettingsPackage.VIEW_SETTINGS__CURSORS:
				return ((InternalEList<?>)getCursors()).basicRemove(otherEnd, msgs);
			case SettingsPackage.VIEW_SETTINGS__TRACE_EVENT_TYPE_CONFIGURATIONS:
				return ((InternalEList<?>)getTraceEventTypeConfigurations()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SettingsPackage.VIEW_SETTINGS__DIAGRAMS:
				return getDiagrams();
			case SettingsPackage.VIEW_SETTINGS__EVENT_LABELS_VISIBLE:
				return isEventLabelsVisible();
			case SettingsPackage.VIEW_SETTINGS__HORIZONTAL_LABELS:
				return isHorizontalLabels();
			case SettingsPackage.VIEW_SETTINGS__CURSORS:
				return getCursors();
			case SettingsPackage.VIEW_SETTINGS__TRACE_EVENT_TYPE_CONFIGURATIONS:
				return getTraceEventTypeConfigurations();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SettingsPackage.VIEW_SETTINGS__DIAGRAMS:
				getDiagrams().clear();
				getDiagrams().addAll((Collection<? extends DiagramSettings>)newValue);
				return;
			case SettingsPackage.VIEW_SETTINGS__EVENT_LABELS_VISIBLE:
				setEventLabelsVisible((Boolean)newValue);
				return;
			case SettingsPackage.VIEW_SETTINGS__HORIZONTAL_LABELS:
				setHorizontalLabels((Boolean)newValue);
				return;
			case SettingsPackage.VIEW_SETTINGS__CURSORS:
				getCursors().clear();
				getCursors().addAll((Collection<? extends Cursor>)newValue);
				return;
			case SettingsPackage.VIEW_SETTINGS__TRACE_EVENT_TYPE_CONFIGURATIONS:
				getTraceEventTypeConfigurations().clear();
				getTraceEventTypeConfigurations().addAll((Collection<? extends TraceEventTypeConfiguration>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SettingsPackage.VIEW_SETTINGS__DIAGRAMS:
				getDiagrams().clear();
				return;
			case SettingsPackage.VIEW_SETTINGS__EVENT_LABELS_VISIBLE:
				setEventLabelsVisible(EVENT_LABELS_VISIBLE_EDEFAULT);
				return;
			case SettingsPackage.VIEW_SETTINGS__HORIZONTAL_LABELS:
				setHorizontalLabels(HORIZONTAL_LABELS_EDEFAULT);
				return;
			case SettingsPackage.VIEW_SETTINGS__CURSORS:
				getCursors().clear();
				return;
			case SettingsPackage.VIEW_SETTINGS__TRACE_EVENT_TYPE_CONFIGURATIONS:
				getTraceEventTypeConfigurations().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SettingsPackage.VIEW_SETTINGS__DIAGRAMS:
				return diagrams != null && !diagrams.isEmpty();
			case SettingsPackage.VIEW_SETTINGS__EVENT_LABELS_VISIBLE:
				return eventLabelsVisible != EVENT_LABELS_VISIBLE_EDEFAULT;
			case SettingsPackage.VIEW_SETTINGS__HORIZONTAL_LABELS:
				return horizontalLabels != HORIZONTAL_LABELS_EDEFAULT;
			case SettingsPackage.VIEW_SETTINGS__CURSORS:
				return cursors != null && !cursors.isEmpty();
			case SettingsPackage.VIEW_SETTINGS__TRACE_EVENT_TYPE_CONFIGURATIONS:
				return traceEventTypeConfigurations != null && !traceEventTypeConfigurations.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (eventLabelsVisible: ");
		result.append(eventLabelsVisible);
		result.append(", horizontalLabels: ");
		result.append(horizontalLabels);
		result.append(')');
		return result.toString();
	}

} //ViewSettingsImpl
